// ErrorLookupEx.cpp : main source file for ErrorLookupEx.exe
//
#include "stdafx.h"
#include "resource.h"
#include "MainDlg.h"


#ifdef _DEBUG
   void test() {
      TCHAR szFileName[] = _T("C:\\qqq\\www.txt");
      HANDLE hFile = ::CreateFile(szFileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
      BOOL bRes = (INVALID_HANDLE_VALUE != hFile);
      if (!bRes) {
         DWORD dwErrCode = ::GetLastError();
         ::OutputDebugString(::Format(_T("File open failed: err code is %i - %s\r\n"), dwErrCode, (LPCTSTR)::ErrCode2Str(dwErrCode)));
      } else {
         // ...
         BOOL bRes2 = ::CloseHandle(hFile); _ASSERT_EXPR(bRes2, L"CloseHandle");
      }
   }

   BOOL CALLBACK ValueNameEnum(IN HKEY hKey, IN LPCTSTR szKey, IN DWORD dwIndex, IN LPCTSTR szValueName, IN DWORD dwType, IN LPVOID lpUserData) {
      const CString &sss = *(CString*)lpUserData;
      //::OutputDebugString(::Format(_T("ValueNameEnum:%s%i: [%s] '%s'\r\n"), (LPCTSTR)sss, dwIndex, (LPCTSTR)szKey, (LPCTSTR)szValueName));

      if (szValueName) {// && szValueName[0]) {
         if (dwType == REG_SZ) {
            CString val = CRegistry::GetString(hKey, szValueName);
            if (!val.IsEmpty())
            if (val.Find(_T("jre_x64_1.6.0_22")) != -1)
            {
               ::OutputDebugString(::Format(_T("ValueNameEnum:   %s: %s%i: '%s'\r\n"), (LPCTSTR)szKey, (LPCTSTR)sss, dwIndex, (LPCTSTR)szValueName));
               val.Replace(_T("jre_x64_1.6.0_22"), _T("jre_1.6.0_22_x64"));
               //DWORD dwErrCode = CRegistry::SetString(hKey, szValueName, val);
               //_ASSERT(dwErrCode == NO_ERROR);
            }
         }
      }

      return TRUE;
   }
   BOOL CALLBACK SubKeyEnum(IN HKEY hKey, IN LPCTSTR szKey, IN DWORD dwIndex, IN LPCTSTR szSubKey, IN LPVOID lpUserData) {
      CString &sss = *(CString*)lpUserData;
      //::OutputDebugString(::Format(_T("SubKeyEnum   :%s%i: [%s\\%s]\r\n"), (LPCTSTR)sss, dwIndex, (LPCTSTR)szKey, (LPCTSTR)szSubKey));

      if (szSubKey && szSubKey[0]) {
         HKEY hSubKey = NULL;
         DWORD dwErrCode = ::RegOpenKeyEx(hKey, szSubKey, 0, KEY_READ, &hSubKey);
         if (dwErrCode != NO_ERROR) {
            //_ASSERT(FALSE);
            ::SetLastError(dwErrCode);
         } else {
            CRegistry::EnumValueName(hSubKey, ValueNameEnum, &(sss+_T("   ")));

            BOOL bRes = CRegistry::EnumSubKeyName(hSubKey, SubKeyEnum, &(sss+_T("   ")));
            dwErrCode = ::GetLastError();
            _ASSERT(bRes);
         }
      }

      return TRUE;
   }
   void replaceJre() {
      //CString sss = _T("   ");
      //HKEY hKey = NULL;
      //DWORD dwErrCode = ::RegOpenKeyEx(HKEY_CLASSES_ROOT, _T("\\CLSID\\{0be3744f-8efe-4416-9a2d-273f154be203}\\"), 0, KEY_READ, &hKey);
      //CRegistry::EnumSubKeyName(hKey, SubKeyEnum, &sss);
      /** /
      CRegistry::EnumSubKeyName(HKEY_CLASSES_ROOT       , SubKeyEnum, &sss);
      CRegistry::EnumSubKeyName(HKEY_CURRENT_USER       , SubKeyEnum, &sss);
      CRegistry::EnumSubKeyName(HKEY_LOCAL_MACHINE      , SubKeyEnum, &sss);
      CRegistry::EnumSubKeyName(HKEY_USERS              , SubKeyEnum, &sss);
      CRegistry::EnumSubKeyName(HKEY_PERFORMANCE_DATA   , SubKeyEnum, &sss);
      CRegistry::EnumSubKeyName(HKEY_PERFORMANCE_NLSTEXT, SubKeyEnum, &sss);
      CRegistry::EnumSubKeyName(HKEY_PERFORMANCE_TEXT   , SubKeyEnum, &sss);
      CRegistry::EnumSubKeyName(HKEY_CURRENT_CONFIG     , SubKeyEnum, &sss);
      CRegistry::EnumSubKeyName(HKEY_DYN_DATA           , SubKeyEnum, &sss);
      /**/
   }
#endif




CAppModule _Module;

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE /*hPrevInstance*/, LPTSTR /*lpstrCmdLine*/, int /*nCmdShow*/)
{
   //replaceJre();
   //test();
	HRESULT hRes = ::CoInitialize(NULL);
// If you are running on NT 4.0 or higher you can use the following call instead to 
// make the EXE free threaded. This means that calls come in on a random RPC thread.
//	HRESULT hRes = ::CoInitializeEx(NULL, COINIT_MULTITHREADED);
	ATLASSERT(SUCCEEDED(hRes));

	// this resolves ATL window thunking problem when Microsoft Layer for Unicode (MSLU) is used
	::DefWindowProc(NULL, 0, 0, 0L);

	AtlInitCommonControls(ICC_BAR_CLASSES);	// add flags to support other controls

	hRes = _Module.Init(NULL, hInstance);
	ATLASSERT(SUCCEEDED(hRes));

	int nRet = 0;
	// BLOCK: Run application
	{
//#ifdef _DEBUG
//		CMainDlgDebug dlgMain;
//#else
		CMainDlg dlgMain;
//#endif
		nRet = dlgMain.DoModal();
	}

	_Module.Term();
	::CoUninitialize();

	return nRet;
}

#ifndef _DEBUG
namespace boost{
   void __cdecl throw_exception(class std::exception const & ex) {
      throw ex;
   }
}
#endif