////////////////////////////////////////////////////////////////////////////////
// File name: DC.h
// Author: Sergey Krivulya (Ce p) - KSerg (SeregaLBN)
// e-mail: Sergey_Krivulya@UkrPost.Net
// ICQ: 72099167
// WWW page: http://kserg77.narod.ru
// Date: 2007 07 16
//
// Description: ,   HDC
////////////////////////////////////////////////////////////////////////////////
// Copyright (C) 2007 Sergey Krivulya
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////////////

#ifndef __FILE__HANDLE_DEVICE_CONTEXT__
#define __FILE__HANDLE_DEVICE_CONTEXT__

#if _MSC_VER > 1000
   #pragma once
#endif // _MSC_VER > 1000

BOOL BitBlt    (HDC, const RECT&, HDC    , const POINT&, DWORD);
BOOL BitBlt    (HDC, const RECT&, HBITMAP, const POINT&, DWORD);
BOOL BitBlt    (HDC, const RECT&, HDC    , /* ={0,0} */  DWORD);
BOOL BitBlt    (HDC, const RECT&, HBITMAP, /* ={0,0} */  DWORD);
BOOL BitBlt    (HDC, const SIZE&, HDC    , const POINT&, DWORD);
BOOL BitBlt    (HDC, const SIZE&, HBITMAP, const POINT&, DWORD);
BOOL BitBlt    (HDC, const SIZE&, HDC    , /* ={0,0} */  DWORD);
BOOL BitBlt    (HDC, const SIZE&, HBITMAP, /* ={0,0} */  DWORD);
BOOL StretchBlt(HDC, const RECT&, HDC    , const RECT&,  DWORD);
BOOL StretchBlt(HDC, const RECT&, HBITMAP, const RECT&,  DWORD);
BOOL StretchBlt(HDC, const RECT&, HDC    , const SIZE&,  DWORD);
BOOL StretchBlt(HDC, const RECT&, HBITMAP, const SIZE&,  DWORD);
BOOL StretchBlt(HDC, const SIZE&, HDC    , const SIZE&,  DWORD);
BOOL StretchBlt(HDC, const SIZE&, HBITMAP, const SIZE&,  DWORD);
BOOL StretchBlt(HDC, const SIZE&, HDC    , const RECT&,  DWORD);
BOOL StretchBlt(HDC, const SIZE&, HBITMAP, const RECT&,  DWORD);

//     
// 1.  
//    : -   (destination context)
//              -        
// 2.   ( )
//    : -   (source context)
//                  (HBITMAP)
//              -     / ( )
//                  LeftTop    / (   )
// 3. .
//    : -  c   -
//              -     ( )   LeftTop     (   )
//           -    (    HBITMAP    )
//           -  ,   (   ! )
//              -     ( )
//                  LeftTop    (   )
//                    1.                 2.                         3. .
BOOL StretchBltMasked(HDC hDCDst, RECT const &rcDst, HDC     hDCSrc , RECT  const &rcSrc , HDC hDCMsk, RECT  const &rcMsk);
BOOL BitBltMasked    (HDC hDCDst, RECT const &rcDst, HDC     hDCSrc , POINT const &pLTSrc, HDC hDCMsk, POINT const &pLTMsk);
BOOL StretchBltMasked(HDC hDCDst, RECT const &rcDst, HBITMAP hBmpSrc, RECT  const &rcSrc , COLORREF clrTransparent);
BOOL BitBltMasked    (HDC hDCDst, RECT const &rcDst, HBITMAP hBmpSrc, POINT const &pLTSrc, COLORREF clrTransparent);
BOOL BitBltMasked    (HDC hDCDst, RECT const &rcDst, HDC     hDCSrc , POINT const &pLTSrc, COLORREF clrTransparent);
BOOL StretchBltMasked(HDC hDCDst, RECT const &rcDst, HDC     hDCSrc , RECT  const &rcSrc , POINT const *pPointsMsk, int nCount, RECT  const &rcMsk);
BOOL BitBltMasked    (HDC hDCDst, RECT const &rcDst, HDC     hDCSrc , POINT const &pLTSrc, POINT const *pPointsMsk, int nCount, POINT const &pLTMsk);

#endif // __FILE__HANDLE_DEVICE_CONTEXT__
